# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.96"
name = "problemo"
version = "0.0.13"
authors = ["Tal Liron"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Problemo"
documentation = "https://docs.rs/problemo"
readme = "README.md"
keywords = ["error"]
categories = ["development-tools"]
license = "MIT OR Apache-2.0"
repository = "https://codeberg.org/tliron/problemo"

[package.metadata.docs.rs]
all-features = true
rustdoc-args = [
    "--cfg",
    "docsrs",
]

[features]
anyhow = ["dep:anyhow"]
backtrace-external = ["dep:backtrace"]
default = ["thin-vec"]
serde = ["dep:serde"]
thin-vec = ["dep:thin-vec"]
wasmtime = ["dep:wasmtime"]

[lib]
name = "problemo"
path = "src/lib.rs"

[[example]]
name = "accumulate"
path = "examples/accumulate.rs"

[[example]]
name = "anyhow"
path = "examples/anyhow.rs"
required-features = ["anyhow"]

[[example]]
name = "debug_context"
path = "examples/debug_context.rs"
required-features = ["backtrace-external"]

[[example]]
name = "dedup"
path = "examples/dedup.rs"

[[example]]
name = "dedup_custom"
path = "examples/dedup_custom.rs"

[[example]]
name = "dyn_accumulate"
path = "examples/dyn_accumulate.rs"

[[example]]
name = "exit_code"
path = "examples/exit_code.rs"

[[example]]
name = "extension_trait"
path = "examples/extension_trait.rs"

[[example]]
name = "function_attachment"
path = "examples/function_attachment.rs"

[[example]]
name = "grouping_types"
path = "examples/grouping_types.rs"

[[example]]
name = "serde"
path = "examples/serde.rs"
required-features = ["serde"]

[[example]]
name = "supertrait"
path = "examples/supertrait.rs"

[[example]]
name = "threads"
path = "examples/threads.rs"

[dependencies.anyhow]
version = "1.0.102"
optional = true

[dependencies.backtrace]
version = "0.3.76"
optional = true

[dependencies.serde]
version = "1.0.228"
optional = true

[dependencies.thin-vec]
version = "0.2.18"
optional = true

[dependencies.wasmtime]
version = "45.0.2"
optional = true
default-features = false

[dev-dependencies.anstream]
version = "1.0.0"

[dev-dependencies.derive_more]
version = "2.1.1"
features = [
    "display",
    "error",
]

[dev-dependencies.owo-colors]
version = "4.3.0"

[dev-dependencies.serde]
version = "1.0.228"
features = ["derive"]
